LoyaltyPointEngine.CMS/Controllers/ResendSMSController.cs
using Grid.Mvc.Ajax.GridExtensions;
using LoyaltyPointEngine.CMS.Helper;
using LoyaltyPointEngine.Data;
using LoyaltyPointEngine.Common;
using LoyaltyPointEngine.Model.Object;
using LoyaltyPointEngine.Model.Parameter.OTP;
using LoyaltyPointEngine.PointLogicLayer.OTP;
using MvcBreadCrumbs;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using LoyaltyPointEngine.Model.Object.OTP;
using LoyaltyPointEngine.Common.Helper;

namespace LoyaltyPointEngine.CMS.Controllers
{
    public partial class ResendSMSController : BaseController
    {
        private IGridMvcHelper gridMvcHelper;

        [BreadCrumb(Clear = true, Label = "Resend SMS")]
        [UserActionFilter(Action = ActionCode.GuidTypes.View)]

        //
        // GET: /ResendSMS/
        public virtual ActionResult Index(string status)
        {
            switch (status)
            {
                case "00":
                    ViewBag.Success = "OTP Code successfully sent";
                    break;
                case "Edit_Success":
                    ViewBag.Success = "OTP Code successfully updated";
                    break;
                case "Delete_Success":
                    ViewBag.Success = "OTP successfully deleted";
                    break;
                default:
                    ViewBag.Success = status;
                    break;
            }
            return View();

        }

        [BreadCrumb(Clear = true, Label = "Get All Image Publish")]
        [UserActionFilter(Action = ActionCode.GuidTypes.View)]
        public virtual ActionResult ResendView(string status)
        {
            switch (status)
            {
                case "Create_Success":
                    ViewBag.Success = "Item successfully created";
                    break;
                case "Edit_Success":
                    ViewBag.Success = "Item successfully updated";
                    break;
                case "Delete_Success":
                    ViewBag.Success = "Item successfully deleted";
                    break;
                case "Resend_Success":
                    ViewBag.Success = "Item successfully Resend";
                    break;
                default:
                    ViewBag.Success = status;
                    break;
            }

            return View();
        }

        [ChildActionOnly]
        public virtual ActionResult GridGetAllResendSMS()
        {

            gridMvcHelper = new GridMvcHelper();
            IOrderedQueryable<PoolOTPMember> allResendSMS = PoolOTPMember.GetByNonPhoneAndNonSuccess().OrderBy(x => x.CreatedDate);
            AjaxGrid<PoolOTPMember> grid = this.gridMvcHelper.GetAjaxGrid(allResendSMS);
            return PartialView(grid);

        }

        [HttpGet]
        public virtual ActionResult GridGetAllResendSMSPager(string txtSearch, int? page)
        {
            gridMvcHelper = new GridMvcHelper();
            IOrderedQueryable<PoolOTPMember> allData = PoolOTPMember.GetByNonPhoneAndNonSuccess().OrderBy(x => x.CreatedDate);
            if (!string.IsNullOrEmpty(txtSearch))
            {
                allData = allData.Where(x => x.OTPCode.Contains(txtSearch) || x.Phone.Contains(txtSearch) || x.Status.Contains(txtSearch) &&
                        x.OTPExpiredDate > DateTime.Now).OrderBy(x => x.CreatedDate);
            }
            AjaxGrid<PoolOTPMember> grid = this.gridMvcHelper.GetAjaxGrid(allData, page);
            object jsonData = this.gridMvcHelper.GetGridJsonData(grid, MVC.ResendSMS.Views.GridGetAllResendSMS, this);

            return Json(jsonData, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [UserActionFilter(Action = ActionCode.GuidTypes.Update)]
        public virtual ActionResult Resend(ResendSMSModel param)
        {
            ResultModel<LoyaltyPointEngine.Model.Object.OTP.OTPMemberModel> res = new ResultModel<LoyaltyPointEngine.Model.Object.OTP.OTPMemberModel>();

            try
            {
                var listId = Request.Form["listID[]"].Split(',');

                foreach (var item in listId)
                {
                    res = OTPLogic.OTPMemberRegister(item, Request.Url.ToString(), CurrentUser.ID, "Loyal CMS", true, CurrentUser.FullName);
                }

            }
            catch (Exception e)
            {
                res.StatusMessage = e.InnerException.Message;
            }

            return Json(new { IsSuccess = res.StatusCode, Message = res.StatusMessage }, JsonRequestBehavior.AllowGet);

        }

        [BreadCrumb(Clear = true, Label = "Upload Member")]
        public virtual ActionResult Upload()
        {
            return View();
        }

        [HttpPost]
        [BreadCrumb(Clear = true, Label = "Upload Member")]
        public virtual ActionResult Upload(HttpPostedFileBase excelFile)
        {
            List<MassResendModel> res = new List<MassResendModel>();

            string url = Request.Url.AbsoluteUri;
            List<string> ListError = new List<string>();
            List<ResendSMSModel> Listdata = new List<ResendSMSModel>();
            ResendSMSModel resModel = new ResendSMSModel();
            string resultFailed = string.Empty;
            if (excelFile != null)
            {
                ExcelDataHelper listData = ExcelHelper.ReadExcel(excelFile);
                if (listData != null)
                {
                    foreach (var item in listData.DataRows)
                    {
                        string phone = item[0].ToString();
                        if (phone.Trim().Length > 0)
                        {
                            if (phone[0] != '0')
                            {
                                phone = "0" + phone;
                            }
                            LoyaltyPointEngine.DataMember.Member member = LoyaltyPointEngine.DataMember.Member.GetByPhone(phone);
                            MassResendModel massResendModel = new MassResendModel();
                            if (member == null)
                            {
                                massResendModel.errCode = "100";
                                massResendModel.errMsg = "nomor tidak ada d sistem kita";
                                massResendModel.phone = phone;
                                res.Add(massResendModel);
                                continue;
                            }

                            if (member.IsActive && !member.IsDeleted)
                            {
                                massResendModel.errCode = "200";
                                massResendModel.errMsg = "nomor sudah aktif tidak perlu dikirim ulang";
                                massResendModel.phone = phone;
                                res.Add(massResendModel);
                                continue;
                            }
                            var result = OTPLogic.OTPMemberRegister(phone, Request.Url.ToString(), CurrentUser.ID, "Loyal CMS", true, CurrentUser.FullName);

                            if (result == null)
                            {
                                massResendModel.errCode = "500";
                                massResendModel.errMsg = "result null";
                                massResendModel.phone = phone;
                                res.Add(massResendModel);
                            }
                            else
                            {
                                massResendModel.errCode = result.StatusCode;
                                massResendModel.errMsg = result.StatusMessage;
                                massResendModel.phone = phone;
                                res.Add(massResendModel);
                            }
                        }
                    }
                }
            }

            return View(res);
        }

        private List<MassResendModel> PopulateUploadModelFromExcelRawDataToModel(HttpPostedFileBase excelFile)
        {
            List<MassResendModel> rawDataFromExel = new List<MassResendModel>();
            ExcelDataHelper listData = ExcelHelper.ReadExcel(excelFile);
            List<string> headers = listData.Headers;
            List<List<string>> datas = listData.DataRows;

            MassResendModel excelModel = new MassResendModel();
            List<string> listHeader = null;
            Dictionary<string, int> HeaderDict = null;

            listHeader = ExcelHelper.ObjectToList(excelModel);
            if (listHeader != null && headers != null)
                HeaderDict = ExcelHelper.ModeltoDictionary(listHeader, headers);


            foreach (List<string> data in datas)
            {
                ExcelHelper.CheckData(data, headers);
                MassResendModel newData = null;
                List<string> rawdata = data;
                newData = ConvertRawDatatoObject(rawdata, HeaderDict);
                if (newData != null)
                {
                    rawDataFromExel.Add(newData);
                }
            }


            return rawDataFromExel;

        }

        private MassResendModel ConvertRawDatatoObject(List<string> rawdata, Dictionary<string, int> dataKey)
        {
            MassResendModel model = new MassResendModel();
            foreach (System.ComponentModel.PropertyDescriptor descriptor in System.ComponentModel.TypeDescriptor.GetProperties(model))
            {
                if (descriptor != null && descriptor.Name != null)
                {
                    if (dataKey.ContainsKey(descriptor.Name))
                    {
                        int index = dataKey[descriptor.Name];
                        switch (descriptor.PropertyType.Name)
                        {
                            case "Int32":

LoyaltyPointEngine.CMS/Views/ResendSMS/GridGetAllResendSMS.cshtml
@using GridMvc.Html
@using GridMvc.Sorting
@model Grid.Mvc.Ajax.GridExtensions.AjaxGrid<PoolOTPMember>

@(
 Html.Grid(Model).Named("GridGetAllResendSMS").Columns(columns =>
 {
     columns.Add()
        .Titled("<input type=\"checkbox\" id=\"All\" class=\"btn btn-xs btn-info\">")
        .Encoded(false)
        .Sanitized(false)
        .SetWidth(50)
        .Css("cell-center")
        .RenderValueAs(x => string.Format("<input type=\"checkbox\" id=\"data\" name=\"param\" value=\"{0}\" class=\"btn btn-xs btn-info data-check\">", x.Phone));

     columns.Add(x => x.Phone)
         .Titled("Phone")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x => x.Phone).Filterable(true);

     columns.Add(x => x.OTPCode)
         .Titled("Code OTP")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x => x.OTPCode).Filterable(true);

     columns.Add(x => x.Status)
         .Titled("Status")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x => x.Status).Filterable(true);

     columns.Add(x => x.OTPExpiredDate)
        .Titled("Expired")
        .Encoded(false)
        .Sanitized(false)
        .Sortable(true)
        .RenderValueAs(x => x.OTPExpiredDate.Value.ToString("dd-MM-yyyy HH:mm")).Filterable(true);

     columns.Add(x => x.CreatedDate)
         .Titled("Created Date")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x => x.CreatedDate.Value.ToString("dd-MM-yyyy HH:mm"));

 }).Filterable()
        .Sortable()
        .WithPaging(10)
)

LoyaltyPointEngine.CMS/Views/ResendSMS/Index.cshtml
@{
    ViewBag.Title = "Index";
}
<!--=== Page Header ===-->
<div class="page-header">
    <div class="page-title">
        <h3>Resend SMS</h3>
    </div>
    <!-- Page Stats -->
    <!-- /Page Stats -->
</div>
<!-- /Page Header -->
<div class="row">
    <div class="col-md-12">
        <div class="widget">
            <div class="widget-header">
                <h4><i class="icon-reorder"></i> All Resend SMS</h4>
            </div>
            <div class="right-title">
                @using (Html.BeginForm(null, null, null, FormMethod.Post, new { id = "gridSearchResendSMS", City = "form" }))
                {
                    <input type="text" id="txtSearch" name="txtSearch" class="form-control box-search" placeholder="Search for...">
                    <button class="hidden" type="submit"></button>
                }
            </div>
            <div class="widget-content">
                @Html.Action("GridGetAllResendSMS")
            </div>
            <button type="submit" id="Resend" class="btn btn-primary">Resend</button>
            <!-- .box-content -->
        </div>
        <!-- .box -->
    </div>
</div>

@section FooterScript{
    <script>
        (function () {
            var gridName = 'GridGetAllResendSMS';
                var pagingUrl = '@Url.Action(MVC.ResendSMS.GridGetAllResendSMSPager())'; 

                $('.grid-mvc').gridmvc();
                pageGrids[gridName].ajaxify({
                    getData: pagingUrl,
                    getPagedData: pagingUrl,
                    gridFilterForm: $('#gridSearchResendSMS')
                });
            }())
    </script>
<script>
    $(document).ready(function () {
        $('#All').click(function () {
            var isChecked = $('#All:checked').prop('checked');
            if (!isChecked) {
                $(".data-check").prop('checked', false);
                //$(".data-check").attr('checked', false);
                console.log(0);
            } else {
                $(".data-check").prop('checked', true);
                //$(".data-check").attr('checked', true);
                console.log(1);
            }
        });
    });
</script>


<script>
    $(document).ready(function () {
        $('#Resend').click(function () { 
            var param = [];
            $("input:checkbox[name='param']:checked").each(function () {
                param.push($(this).val());
            });
            
            if (param.length >= 1) {
                        $.ajax({
                            type: 'post',
                            url: '@Url.Action(MVC.ResendSMS.Resend())',
                            data: { 'listID': param },
                            success: function (e) {
                                console.log(e);
                                if (e.IsSuccess == "00") {
                                    window.location = "@Url.Action(MVC.ResendSMS.Index())" + "?status=" + e.IsSuccess;
                                } else {
                                    window.location = "@Url.Action(MVC.ResendSMS.Index())" + "?status=" + e.Message;
                                }
                                }
                            });
                        
                        ViewData.Clear();
                      } else {

                        alert('Mohon pilih dahulu');
                        return false;
                    }
                });
            });
    </script>
}

LoyaltyPointEngine.CMS/Views/ResendSMS/Upload.cshtml
@using LoyaltyPointEngine.Model.Object.OTP

@model List<MassResendModel>
<!--=== Page Header ===-->
<div class="page-header">
    <div class="page-title">
        <h3>Upload Member</h3>
    </div>    <!-- Page Stats -->
    @*<ul class="page-stats">
        <li>
            <a href="@Url.Action(MVC.ResendSMS.DownloadExcelTemplate())" class="btn btn-icon input-block-level">
                <i class="icon-group"></i>
                <div>Download Excel Templates</div>
            </a>
        </li>
    </ul>*@
    <!-- /Page Stats -->
</div>
<!-- /Page Header -->

<div class="row">
        
    <div class="col-md-12">
            @*@if (ListError != null && ListError.Count >0)
            {
                <div class="alert alert-danger">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <i class="fa fa-times-circle"></i>
                    Error occured: <br />
                    @Html.ValidationSummary()
                    <hr />
                    @if (ListError.Count > 0)
                    {
                        <ul style="list-style-type:circle;">
                            @foreach (var err in ListError)
                            {
                                <li>
                                    @err
                                </li>
                            }
                        </ul>
                    }
                </div>
            }*@

            @using (Html.BeginForm("Upload", "ResendSMS", FormMethod.Post, new { enctype = "multipart/form-data" }))
            {
                <div class="form-group">
                    <label class="col-md-12 control-label"><i>firstname, phone, and ChildDOB is mandatory</i></label>
                </div>
                <div class="form-group">
                    <div class="col-md-4">
                        <input type="file" name="excelFile" class="btn btn-primary" />
                    </div>
                    <div class="col-md-1">
                        <button type="button" class="btn btn-primary" id="btnSubmit" style="margin-top:6px;">Submit</button>
                    </div>
                </div>
                
            }
            <br />
            <br />
    </div>
</div>
@if (Model != null )
{
    int row = 1;
    <div>Total Data : @ViewBag.TotalData</div>
    <div id="grid-wrapper" class="widget-content">
        <table class="table table-striped grid-table">
            <thead>
                <tr>
                    <th class="grid-header" title="Row"><div class="grid-header-title">Row</div></th>
                    <th class="grid-header" title="FirstName"><div class="grid-header-title">phone</div></th>
                    <th class="grid-header" title="Email"><div class="grid-header-title">error code</div></th>
                    <th class="grid-header" title="Phone"><div class="grid-header-title">error message</div></th>                    
                </tr>
            </thead>
            <tbody>
                @foreach (MassResendModel member in Model)
                {
                    <tr class="grid-row">
                        <td class="grid-cell">@row</td>
                        <td class="grid-cell">@member.phone</td>
                        <td class="grid-cell">@member.errCode</td>
                        <td class="grid-cell">@member.errMsg</td>
                        
                    </tr>
                    row++;
                }
            </tbody>
        </table>
    </div>
}

        @section FooterScript {
            <script type="text/javascript">
                $(document).ready(function () {
                    $('#btnSubmit').click(function () {
                        var fileName = $('[name="excelFile"]').val().trim();

                        var pos = fileName.lastIndexOf('.');
                        var extension = (pos <= 0) ? '' : fileName.substring(pos);
                        if (extension != '.xlsx') {
                            alert('Please browse a correct excel file to upload');
                            return;
                        }

                        $('form').submit();
                    });
                    if ('@ViewBag.success' != "") {
                        $('#upload-modal-message').html('@ViewBag.success');
                        $('#myModalExcel').modal();
                    }
                });
            </script>
        }